var gSpellChecker = null;
var popupOn = false;

function windowClose() {
    window.close();
}

function deleteClose() {
    if(nsPreferences.getBoolPref("buttons.nowaitondelete", false)) {
        if(nsPreferences.getBoolPref("buttons.focusafterdelete", false) && window.opener)
            window.opener.focus();
        MsgDeleteMessageFromMessageWindow(false,true);
        window.close();
    } else {
        window.content.onunload = function() {
            if(nsPreferences.getBoolPref("buttons.focusafterdelete", false) && window.opener)
                window.opener.focus();
            window.close();
        };
        MsgDeleteMessageFromMessageWindow(false,true);
    }
}

function forwardClose(event) {
    MsgForwardMessage(event);
    window.close();
}

function replyClose(event) {
    MsgReplyMessage(event);
    window.close();
}

function replyAllClose(event) {
    MsgReplyToAllMessage(event);
    window.close();
}

function realNextMessageWindow(event) {
    var oldMessageURI = GetLoadedMessage();
	if(nsPreferences.getBoolPref("buttons.reversenav", false)) {
        bRealNavigate(event, true, false);
	} else {
        bRealNavigate(event, false, false);
	}
    if(oldMessageURI == GetLoadedMessage() && nsPreferences.getBoolPref("buttons.closeafternav", false)) {
        if(nsPreferences.getBoolPref("buttons.focusafternav", false) && window.opener) {
            window.opener.focus();
        }
        window.close();
    }
}

function realPreviousMessageWindow(event) {
    var oldMessageURI = GetLoadedMessage();
	if(nsPreferences.getBoolPref("buttons.reversenav", false)) {
        bRealNavigate(event, false, false);
	} else {
        bRealNavigate(event, true, false);
	}
    if(oldMessageURI == GetLoadedMessage() && nsPreferences.getBoolPref("buttons.focusmainafternav", false)) {
        if(window.opener) {
            window.opener.focus();
        }
        window.close();
    }
}

function bRealNavigate(event, dirPrev, srcMain) {
	if(dirPrev) {
		if(srcMain) {
			if (event && event.shiftKey) {
				return MsgPreviousUnreadMessage();
			} else {
				return GoNextMessage(nsMsgNavigationType.previousMessage, false );
			}
		} else {
			if (event && event.shiftKey) {
				return performNavigation(nsMsgNavigationType.previousUnreadMessage);
			} else {
				return LoadMessageByNavigationType(nsMsgNavigationType.previousMessage);
			}
		}
	} else {
		if(srcMain) {
			if (event && event.shiftKey) {
				return MsgNextUnreadMessage();
			} else {
				return GoNextMessage(nsMsgNavigationType.nextMessage, false );
			}
		} else {
			if (event && event.shiftKey) {
				return performNavigation(nsMsgNavigationType.nextUnreadMessage);
			} else {
				return LoadMessageByNavigationType(nsMsgNavigationType.nextMessage);
			}
		}
	}
}

function realNextMessage(event) {
	if(nsPreferences.getBoolPref("buttons.reversenav", false)) {
		bRealNavigate(event, true, true);
	} else {
		bRealNavigate(event, false, true);
	}
}

function realPreviousMessage(event) {
	if(nsPreferences.getBoolPref("buttons.reversenav", false)) {
		bRealNavigate(event, false, true);
	} else {
		bRealNavigate(event, true, true);
	}
}

function openSMTPSelect() {
    if (popupOn)
        return;

    var watcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
    var e = watcher.getWindowByName("smtp", null);

    if (e) {
        e.focus();
    } else {
        var args = {result: false};
        window.openDialog('chrome://messenger/content/SmtpServerList.xul', 'smtp', 'modal,titlebar,chrome', args);
    }
}

// Thanks to Torisugari for this function!
function isInChromeAndEnabled(aResourceURI)
{
   try{
      var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
               .getService(Components.interfaces.nsIRDFService);
      var Container = Components.classes["@mozilla.org/rdf/container;1"]
               .getService(Components.interfaces.nsIRDFContainer);

      var chromeDS=RDFService.GetDataSource("rdf:chrome");
      var cResource=RDFService.GetResource("urn:mozilla:package:root");
      var disabledArc=RDFService
               .GetResource("http://www.mozilla.org/rdf/chrome#disabled");

      var target=RDFService.GetResource(aResourceURI);
      Container.Init(chromeDS,cResource);

      return (Container.IndexOf(target) > -1) &&
            !chromeDS.hasArcOut(target,disabledArc);
   }catch(e) {}
   return false;
}

function bSMTPDropInit() {
    var p = document.getElementById("SMTPDropDown");
    var smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"].getService(Components.interfaces.nsISmtpService);
    var servers = smtpService.smtpServers;
    var defaultSMTP = smtpService.defaultServer;
    var serverCount = servers.Count();
    var ssunInstalled = isInChromeAndEnabled("urn:mozilla:package:ssun");

    var showUsername = false;
    var useAlias = false;
    var hideUsername = true;

    if (ssunInstalled) {
        useAlias = nsPreferences.getBoolPref("ssun.showalias", true);
        showUsername = nsPreferences.getBoolPref("ssun.showusername", true);
        hideUsername = nsPreferences.getBoolPref("ssun.hideusername", true);
    }

    var server;
    var myKey;

    for (var i = 0; i < serverCount; ++i) {
        server = servers.QueryElementAt(i, Components.interfaces.nsISmtpServer);
        var menuitem = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
        menuitem.setAttribute("value", server.key);

        var hostname = server.hostname;
        var port = "";

        if (server.port)
            port = ":" + server.port;

        var alias = "";
        if (useAlias) {
            alias = nsPreferences.getLocalizedUnicharPref("ssun." + server.key + ".alias", "");
            if (alias) {
                hostname = alias;
            } else {
                hostname += port;
            }
        } else {
            hostname += port;
        }

        if (showUsername && (!useAlias || (useAlias && (!alias || !hideUsername))) && server.authMethod && server.username)
            hostname += " (" + server.username + ")";

        menuitem.setAttribute("label", hostname);
        menuitem.setAttribute("type", "radio");

        if (server.key == defaultSMTP.key) {
            menuitem.setAttribute("checked", true);
        }

        menuitem.setAttribute("tooltiptext", server.hostname);
        menuitem.setAttribute("oncommand", "bSMTPSelectDefault(this);");
        p.appendChild(menuitem);
    }
}

function bSMTPSelectDefault(p) {
    var smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"].getService(Components.interfaces.nsISmtpService);
    if (p.value != smtpService.defaultServer.key) {
        smtpService.defaultServer = smtpService.getServerByKey(p.value);
    }
    popupOn = true;
}

function buttonsDeleteJunk() {
    var enabled = new Object();
    enabled.value = false;
    var checkStatus = new Object();
    if (gDBView)
        gDBView.getCommandStatus(nsMsgViewCommandType.deleteJunk, enabled, checkStatus);

    // Run command if valid
    if (enabled.value) {
        var bypassTrash = nsPreferences.getIntPref("buttons.bypasstrash", 0);

        if (bypassTrash == 1) {
            var folderTree = GetFolderTree();
            var folderResource = GetFolderResource(folderTree, GetSelectedFolderIndex());
            var specialFolder = GetFolderAttribute(folderTree, folderResource, "SpecialFolder");

            if (specialFolder != "Junk")
                bypassTrash = 0;
        }

        if (bypassTrash == 0) {
            // Delete junk into Trash
            deleteJunkInFolder();
        } else {
            // Delete junk bypassing Trash
            /* Copied from deleteJunkInFolder() in mailCommands.js
               Changed if statements so we don't return out of function
            */
            MsgJunkMailInfo(true);
            var view = GetDBView();

            // need to expand all threads, so we find everything
            view.doCommand(nsMsgViewCommandType.expandAll);

            var treeView = view.QueryInterface(Components.interfaces.nsITreeView);
            var count = treeView.rowCount;
            if (count) {
                var treeSelection = treeView.selection;

                var clearedSelection = false;

                // select the junk messages
                for (var i = 0; i < count; i++) {
                    var messageUri = view.getURIForViewIndex(i);
                    var msgHdr = messenger.messageServiceFromURI(messageUri).messageURIToMsgHdr(messageUri);
                    var junkScore = msgHdr.getStringProperty("junkscore");
                    var isJunk = ((junkScore != "") && (junkScore != "0"));
                    // if the message is junk, select it.
                    if (isJunk) {
                      // only do this once
                      if (!clearedSelection) {
                        // clear the current selection
                        // since we will be deleting all selected messages
                        treeSelection.clearSelection();
                        clearedSelection = true;
                        treeSelection.selectEventsSuppressed = true;
                      }
                      treeSelection.rangedSelect(i, i, true /* augment */);
                    }
                }

                // if we didn't clear the selection
                // there was no junk, so bail.
                if (clearedSelection) {
                    treeSelection.selectEventsSuppressed = false;
                    // delete the selected messages
                    //
                    // XXX todo
                    // should we try to set next message after delete
                    // to the message selected before we did all this, if it was not junk?

                    SetNextMessageAfterDelete();
                    view.doCommand(nsMsgViewCommandType.deleteNoTrash);
                    ClearThreadPaneSelection();

                    // clear message pane if nothing left
                    window.setTimeout('var view = GetDBView();var treeView = view.QueryInterface(Components.interfaces.nsITreeView);if(treeView.rowCount == 0) {gHaveLoadedMessage = true;ClearMessagePane();}', 1);
                }
            }
        }
    }
}

function bToggleHTML() {
    var prefer_plaintext = nsPreferences.getBoolPref("mailnews.display.prefer_plaintext", false);
    var html_as = nsPreferences.getIntPref("mailnews.display.html_as", 0);
    var disallow_classes = nsPreferences.getIntPref("mailnews.display.disallow_mime_handlers", 0);

    var Sanitized_checked = false;
    var AsPlaintext_checked = false;
    if (!prefer_plaintext && html_as == 3 && disallow_classes > 0)
        Sanitized_checked = true;
    else if (prefer_plaintext && html_as == 1 && disallow_classes > 0)
        AsPlaintext_checked = true;

    var htmlSwitch = nsPreferences.getIntPref("buttons.htmlswitch", 0);
    switch (htmlSwitch) {
        case 0:
            if (AsPlaintext_checked)
                MsgBodyAllowHTML();
            else
                MsgBodyAsPlaintext();
            break;
        case 1:
            if (AsPlaintext_checked)
                MsgBodySanitized();
            else
                MsgBodyAsPlaintext();
            break;
        case 2:
            if (Sanitized_checked)
                MsgBodyAllowHTML();
            else
                MsgBodySanitized();
            break;
        default:
            break;
    }
    //bUpdateButtons();
}

function bToggleImages() {
    var showImages = nsPreferences.getBoolPref("mailnews.message_display.disable_remote_image", false);
    nsPreferences.setBoolPref("mailnews.message_display.disable_remote_image", !showImages);
    MsgReload();
    //bUpdateButtons();
}

function bMarkAndDelete() {
    MsgMarkMsgAsRead(true);

    // if the user deletes a message before its mark as read timer goes off, we should mark it as read
    // this ensures that we clear the biff indicator from the system tray when the user deletes the new message
    if (gMarkViewedMessageAsReadTimer)
    {
      MarkCurrentMessageAsRead();
      ClearPendingReadTimer();
    }
    SetNextMessageAfterDelete();
    gDBView.doCommand(nsMsgViewCommandType.deleteMsg);
}

function bMoveMessage(destUri) {
  try {
    var destResource = RDF.GetResource(destUri);
    var destMsgFolder = destResource.QueryInterface(Components.interfaces.nsIMsgFolder);

    if (isNewsURI(gDBView.msgFolder.URI)) {
      gDBView.doCommandWithFolder(nsMsgViewCommandType.copyMessages, destMsgFolder);
    }
    else {
      SetNextMessageAfterDelete();
      gDBView.doCommandWithFolder(nsMsgViewCommandType.moveMessages, destMsgFolder);
    }
  } catch (ex) { }
}

function bArchiveMessageDefault(buttonElem) {
    if (popupOn)
        return;

	var defaultFolder = nsPreferences.getLocalizedUnicharPref("buttons.archive.default", "");
	if(!defaultFolder) {
		document.getElementById("bArchiveDropDown").showPopup();
	} else {
		bMoveMessage(defaultFolder);
	}
}

function bArchiveDropInit() {
	var p = document.getElementById("bArchiveDropDown");
	var folders = nsPreferences.getLocalizedUnicharPref("buttons.archive.folders", "");
	var defaultFolder = nsPreferences.getLocalizedUnicharPref("buttons.archive.default", "");
	if(folders) {
		folders = folders.split("///");
		for(var i = 0; i < folders.length; ++i) {
			var msgFolder = GetMsgFolderFromUri(folders[i], true);
			if(msgFolder) {
				var menuitem = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
				menuitem.setAttribute("label", document.getElementById("bundle_messenger").getFormattedString("verboseFolderFormat", [msgFolder.name, msgFolder.server.prettyName]));
				menuitem.setAttribute("value", folders[i]);
				menuitem.setAttribute("type", "radio");

				if (defaultFolder && folders[i] == defaultFolder) {
					menuitem.setAttribute("checked", true);
				}

				menuitem.setAttribute("oncommand", "bMoveMessage(this.getAttribute('value'));");

				p.appendChild(menuitem);
			}
		}
	} else {
		var menuitem = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
		menuitem.setAttribute("label", "(Empty)");
		menuitem.setAttribute("disabled", true);
		p.appendChild(menuitem);
	}
}

function bClearDropdown(p) {
    while (p.hasChildNodes())
        p.removeChild(p.firstChild);
}

function bOpenSpellCheck() {
    if (popupOn)
        return;

    window.cancelSendMessage = false;
    try {
      var skipBlockQuotes = (window.document.firstChild.getAttribute("windowtype") == "msgcompose");
      window.openDialog("chrome://editor/content/EdSpellCheck.xul", "_blank",
              "chrome,close,titlebar,modal", false, skipBlockQuotes, true);
    }
    catch(ex) {}
    window.content.focus();
}

function bSpellDropInit() {
  var p = document.getElementById("bSpellDropDown");
  var o1 = {};
  var o2 = {};

  // Get the list of dictionaries from
  // the spellchecker.

  if(!gSpellChecker) {
      gSpellChecker = Components.classes['@mozilla.org/editor/editorspellchecker;1'].createInstance(Components.interfaces.nsIEditorSpellCheck);
      if (!gSpellChecker)
      {
        dump("SpellChecker not found!!!\n");
        return;
      }
  }

  gSpellChecker.InitSpellChecker(GetCurrentEditor(), true);

  var curLang;

  try {
    curLang = gSpellChecker.GetCurrentDictionary();
  } catch(ex) {
    curLang = "";
  }

  try {
    gSpellChecker.GetDictionaryList(o1, o2);
  } catch(ex) {
    dump("Failed to get DictionaryList!\n");
    return;
  }

  var dictList = o1.value;
  var count    = o2.value;

  // Load the string bundles that will help us map
  // RFC 1766 strings to UI strings.

  // Load the language string bundle.
  var languageBundle = document.getElementById("languageBundle");
  var regionBundle;
  // If we have a language string bundle, load the region string bundle.
  if (languageBundle)
    regionBundle = document.getElementById("regionBundle");

  var menuStr2;
  var isoStrArray;
  var defaultItem = null;
  var langId;
  var i;
  for (i = 0; i < dictList.length; i++)
  {
    try {
      langId = dictList[i];
      isoStrArray = dictList[i].split("-");

      dictList[i] = new Array(2); // first subarray element - pretty name
      dictList[i][1] = langId;    // second subarray element - language ID

      if (languageBundle && isoStrArray[0])
        dictList[i][0] = languageBundle.getString(isoStrArray[0].toLowerCase());

      if (regionBundle && dictList[i][0] && isoStrArray.length > 1 && isoStrArray[1])
      {
        menuStr2 = regionBundle.getString(isoStrArray[1].toLowerCase());
        if (menuStr2)
          dictList[i][0] = dictList[i][0] + "/" + menuStr2;
      }

      if (!dictList[i][0])
        dictList[i][0] = dictList[i][1];
    } catch (ex) {
      // GetString throws an exception when
      // a key is not found in the bundle. In that
      // case, just use the original dictList string.

      dictList[i][0] = dictList[i][1];
    }
  }

  // note this is not locale-aware collation, just simple ASCII-based sorting
  // we really need to add loacel-aware JS collation, see bug XXXXX
  dictList.sort();

  for (i = 0; i < dictList.length; i++)
  {
    var menuitem = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
    menuitem.setAttribute("value", dictList[i][1]);
    menuitem.setAttribute("label", dictList[i][0]);
    menuitem.setAttribute("type", "radio");

    if (curLang && dictList[i][1] == curLang) {
        menuitem.setAttribute("checked", true);
    }

    menuitem.setAttribute("tooltiptext", dictList[i][0]);
    menuitem.setAttribute("oncommand", "bSpellSelectDefault(this);");
    p.appendChild(menuitem);
  }
}

function bSpellSelectDefault(p) {
  if (!gSpellChecker)
  {
    dump("SpellChecker not found!!!\n");
  } else {
      try {
          gSpellChecker.SetCurrentDictionary(p.value);
          gSpellChecker.UninitSpellChecker();
      }
      catch (ex) {}
      finally { gSpellChecker = null; }
  }

  popupOn = true;
}

function bDeleteThread(event) {
    if(nsPreferences.getBoolPref("buttons.noconfirmondelete", false) || confirm(messages.deleteThreadConfirm)) {
        gDBView.doCommand(nsMsgViewCommandType.selectThread);
		SetNextMessageAfterDelete();
        gDBView.doCommand(nsMsgViewCommandType.deleteMsg);
    }
}

function bUpdateButtons() {
    try {
        var bHTML = document.getElementById("ToggleHTML");
        if(bHTML) {
    		var prefer_plaintext = nsPreferences.getBoolPref("mailnews.display.prefer_plaintext", false);
			var html_as = nsPreferences.getIntPref("mailnews.display.html_as", 0);
			var disallow_classes = nsPreferences.getIntPref("mailnews.display.disallow_mime_handlers", 0);

			var Sanitized_checked = false;
			var AsPlaintext_checked = false;
		    if (!prefer_plaintext && html_as == 3 && disallow_classes > 0)
				Sanitized_checked = true;
			else if (prefer_plaintext && html_as == 1 && disallow_classes > 0)
				AsPlaintext_checked = true;

			var htmlSwitch = nsPreferences.getIntPref("buttons.htmlswitch", 0);
			switch (htmlSwitch) {
                case 0:
                    if (AsPlaintext_checked)
                        // set turnon_
                        bToggleButtonState(bHTML,"on");
                    else
                        // set turnoff_
                        bToggleButtonState(bHTML,"off");
                    break;
                case 1:
                    if (AsPlaintext_checked)
                        // set turnon_
                        bToggleButtonState(bHTML,"on");
                    else
                        // set turnoff_
                        bToggleButtonState(bHTML,"off");
                    break;
                case 2:
                    if (Sanitized_checked)
                        // set turnon_
                        bToggleButtonState(bHTML,"on");
                    else
                        // set turnoff_
                        bToggleButtonState(bHTML,"off");
                    break;
                default:
                    break;
            }
        }

        var bImage = document.getElementById("ToggleImages");
        if(bImage) {
			var hideImages = nsPreferences.getBoolPref("mailnews.message_display.disable_remote_image", false);
            if(hideImages) {
                // set to turnon_
                bToggleButtonState(bImage,"on");
            } else {
                // set to turnoff_
                bToggleButtonState(bImage,"off");
            }
        }
    } catch (e) {}
}

function bToggleButtonState(elem, state) {
    try {
        //elem.label = elem.getAttribute('turn' + state + '_label');
        elem.setAttribute('tooltiptext', elem.getAttribute('turn' + state + '_tooltiptext'));
        elem.setAttribute('bstate', state);
    } catch (e) {}
}

var bButtonUpdateObserver = {
    observe: function(subject,topic,data) {
        if(topic == "nsPref:changed")
            bUpdateButtons();
    }
};

var bOldWindowOnLoad = window.onload;
window.onload = function() {
	bOldWindowOnLoad();
    var bPrefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranchInternal);
    bPrefService.addObserver("mailnews.message_display.disable_remote_image", bButtonUpdateObserver, false);
    bPrefService.addObserver("mailnews.display.prefer_plaintext", bButtonUpdateObserver, false);
    bPrefService.addObserver("mailnews.display.html_as", bButtonUpdateObserver, false);
    bPrefService.addObserver("mailnews.display.disallow_mime_handlers", bButtonUpdateObserver, false);
    bUpdateButtons();
}

var bOldWindowOnUnload = window.onunload;
window.onunload = function() {
	bOldWindowOnUnload();
    var bPrefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranchInternal);
    bPrefService.removeObserver("mailnews.message_display.disable_remote_image", bButtonUpdateObserver);
    bPrefService.removeObserver("mailnews.display.prefer_plaintext", bButtonUpdateObserver);
    bPrefService.removeObserver("mailnews.display.html_as", bButtonUpdateObserver);
    bPrefService.removeObserver("mailnews.display.disallow_mime_handlers", bButtonUpdateObserver);
}
